/*
**	kibacorp inc graphics library Test used for EA DOGM128-6 display
** modified 3/14 for new experimenter board with exception of RPX
6/21/09 thk Modifed to run EA DOG128-6  SPI port
6/22/09 thk speed up SPI port 1;1 prescale CKE and CKP changes not necessary
6/22/09 thk added VMap array for on chip memory map of display
7/2/09 thk begin to transition to graphics library -rectangle (x,y,x,y) circle (x,y,r)
7/3/09 thk fill bar , draws isocolles and right triangle with fill
7/19/09 thk  added font generation and completed demo
8/11/09 thk added yellow/green display and attempting to set constrast--works
8/21/08 thk added lcd.c and lcd.h to run dual displays
9/26/09 thk rewrite to accomodate graphicsd library articilte for Nuts and volts
9/26/09 thk adding bit map 32x32 display capability
9/27/09 added bitmaps demo
*/

#include <p24fj64ga002.h>

#include "graphics.h"
#include "Delay.h"
#include "lcd.h"
#include "shuttle.h"
#include "saturn.h"
#include "sun.h"
#include "telescope.h"
#include "rocket.h"
#include "robot.h"
#include "voyager.h"
#include "earth.h"
#include "spacecraft.h"
#include "moon.h"
#include "spacestation.h"
#include "pioneer.h"
#include "jupiter.h"
#include "robbie.h"
#include "bitmap_key.h"
#include "mexican32x32.h"
#include "kibacorp.h"
const char Message0[]=    " Graphic demo";
const char Message1[]=    " Random lines";
const char Message2[]=    " Waveform demo";
const char Message3[]=    " Shapes demo";
const char Message4[]=    " Fonts demo";
const char Message5[]=    " Thank You";
const char Message6[]=    " Bitmaps demo";

main( void)
{
	
	
    // I/O initializations
  	CLKDIVbits.RCDIV = 0;
  	 AD1PCFG = 0xffff;   // initialize to all digital
    
__builtin_write_OSCCONL(OSCCON & 0xbf) ; //clear bit 6


	RPINR22bits.SDI2R =  9;  // make Pin RP9 SDI2



	RPOR3bits.RP7R =10;   //SDO2  RP7
	RPOR4bits.RP8R = 11; // SCK2OUT RP8

__builtin_write_OSCCONL(OSCCON | 0x40) ; //set bit 6
	initLCDIo();
	LCDInit();
    initSD();
   	clearScreen();
   	int i=0;


	
	
	
	
	  
    
 while(1) { 
	 //output on char LCD
	 clear_display(); 
	 move_FirstLine();
	for ( i=0; Message0[i] !=0; i++)
	LCDWrite(Message0[i],1);	
   AT( 0, 0) ; 
   putsV( " Graphics demo");
   AT(0,1);
    putsV( "  for the  ");
     AT(0,2);  
   putsV( " 16 bit Micro"); 
   AT(0,3)
   putsV( " Experimenter"); 
   drawbitmap32x32 ( &bitmapshuttle,0,32);
   drawbitmap32x32 ( &bitmapsun,32,32);
   drawbitmap32x32 ( &bitmapmoon,64,32);
   drawbitmap32x32 ( &bitmaprocket,92,32);
   
    dumpVmap();
    	big_delay();
	clearScreen();
	 //output on char LCD
	 clear_display(); 
	 move_FirstLine();
	for ( i=0; Message1[i] !=0; i++)
	LCDWrite(Message1[i],1);
 AT( 0, 2) ;
  putsV( " Random Line" );	
  AT( 0, 3) ;
  putsV( " Demostration " );
  dumpVmap();
  	big_delay();
   clearScreen();
     random_line_demo();
  clearScreen();
 plotxsinx();
  //output on char LCD
	 clear_display(); 
	 move_FirstLine();
	for ( i=0; Message2[i] !=0; i++)
	LCDWrite(Message2[i],1);
  AT( 0, 7) ;
  putsV( "Waveform Demo");
  dumpVmap();
 big_delay();
 clearScreen();
 //added  new bitmaps demo *************
 clear_display(); 
	for ( i=0; Message6[i] !=0; i++)
 	LCDWrite(Message6[i],1);
   AT(0,0)
   putsV( "32x32 bitmaps");
   //stack up 4 bitmaps in a row on display round 1
   drawbitmap32x32 ( &bitmapshuttle,0,20);
   drawbitmap32x32 ( &bitmapsun,32,20);
   drawbitmap32x32 ( &bitmapmoon,64,20);
   drawbitmap32x32 ( &bitmaprocket,92,20);
   dumpVmap();
    big_delay();
      big_delay();
 clearScreen();
 AT(0,0)
   putsV( "32x32 bitmaps");
   //stack up 4 bitmaps in a row on display round 2
   drawbitmap32x32 ( &bitmaptelescope,0,20);
   drawbitmap32x32 ( &bitmaprobot,32,20);
   drawbitmap32x32 ( &bitmaprobbie,64,20);
   drawbitmap32x32 ( &bitmapvoyager,92,20);
 dumpVmap();
 big_delay();
   big_delay();
 clearScreen();
 AT(0,0)
   putsV( "32x32 bitmaps");
   //stack up 4 bitmaps in a row on display round 3
   drawbitmap32x32 ( &bitmapspacestation,0,20);
   drawbitmap32x32 ( &bitmappioneer,32,20);
   drawbitmap32x32 ( &bitmapsaturn,64,20);
   drawbitmap32x32 ( & bitmapspacecraft,92,20);
   // drawbitmap32x32 ( & bitmapkibacorp,92,20);
 //*********bit maps demo end ****************
  dumpVmap();
 big_delay();
   big_delay();
 clearScreen();
	Triangle (80,5,100,50);


 rightTriangle ( 12,4, 30, 20); //small right triangle
 Rectangle (34,8,48,20);
 Bar ( 110,40,120,60); //small rectangle below it
  Circle ( 110,22,15);
   //output on char LCD
	 clear_display(); 
	 move_FirstLine();
	for ( i=0; Message3[i] !=0; i++)
	LCDWrite(Message3[i],1);
  AT( 0, 7) ;
  putsV( " Shapes Demo");
    dumpVmap();
    big_delay();
 clearScreen();
  //output on char LCD
	 clear_display(); 
	 move_FirstLine();
	for ( i=0; Message4[i] !=0; i++)
	LCDWrite(Message4[i],1);
  AT( 0, 0) ;
  
  putsV( "   8x8 Font" );	
  AT( 0, 1) ;
  putsV( " Demostration " );
  AT (0,3);
  putsV("0123456789");
  AT (0,4);
  putsV("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  putsV("abcdefghijklmnopqrstuvwxyz");
  putsV("!@#$%^&*()+");
     dumpVmap();  
     big_delay();
       big_delay();
 clearScreen();
  //output on char LCD
	 clear_display(); 
	 move_FirstLine();
	for ( i=0; Message5[i] !=0; i++)
	LCDWrite(Message5[i],1);
  AT( 0, 2) ;
  putsV( " Thank You" );	
  
  dumpVmap();
   big_delay();
 } 
   while( 1);

} // main

