#include <p24fj64ga002.h>
#include "adc.h"



int readADC( int IOpin)
{
	
    AD1CHS  = IOpin;               // select analog input channel based upon I/o epxansion pin
    AD1CON1bits.SAMP = 1;       // start sampling, automatic conversion will follow
    while (!AD1CON1bits.DONE);   // wait to complete the conversion
    return ADC1BUF0;            // read the conversion result
} // readADC
void initADC( int IOpin) 
{
    AD1PCFG =mask_translate(IOpin) ;    // select analog input pins
    AD1CON1 = 0x00E0;   // auto convert after end of sampling 
    AD1CSSL = 0;        // no scanning required 
    AD1CON3 = 0x1F02;   // max sample time = 31Tad, Tad = 2 x Tcy = 125ns >75ns
    AD1CON2 = 0;        // use MUXA, AVss and AVdd are used as Vref+/-
    AD1CON1bits.ADON = 1; // turn on the ADC
} //initADC
int mask_translate(int IOpin) {
	int tempmask =0xfdff;   //default to pin 10
	if (IOpin==4) tempmask= 0xffef;
	if (IOpin==7) tempmask= 0xff7f;
	if (IOpin==12) tempmask= 0xefff;
	if (IOpin==11) tempmask= 0xf7ff;
	if (IOpin==10) tempmask= 0xfbff;
	if (IOpin==9) tempmask= 0xfdff;
	return tempmask;
	
}	